﻿using System;
using System.Linq;
using System.Windows.Forms;
using System.Diagnostics;

namespace Process_Kill_Slowdown_Test_C_Sharp {
    class Program {
        private const short shortNumberOfProcessesToStart = 1000;

        static void Main(string[] args) {
            try {
                if (args.Count() >= 1) {
                    string commandLineArgument = args[0].ToString();

                    if (commandLineArgument.Equals("-sleeping", StringComparison.OrdinalIgnoreCase)) {
                        startagain:
                        System.Threading.Thread.Sleep(1000);
                        goto startagain;
                    }
                }
                else {
                    Console.WriteLine("================================");
                    Console.WriteLine("== Process Kill Slowdown Test ==");
                    Console.WriteLine("================================");

                    Console.WriteLine("Spawning " + shortNumberOfProcessesToStart.ToString() + " processes... LOL");

                    Process[] ourChildProcesses = new Process[shortNumberOfProcessesToStart + 2];
                    ProcessStartInfo processStartInfo = new ProcessStartInfo {
                        FileName = new System.IO.FileInfo(Application.ExecutablePath).FullName,
                        Arguments = "-sleeping",
                        CreateNoWindow = true,
                        WindowStyle = ProcessWindowStyle.Hidden
                    };

                    for (int i = 0; i <= shortNumberOfProcessesToStart; i++) {
                        ourChildProcesses[i] = Process.Start(processStartInfo);
                    }

                    Console.WriteLine("Now killing our processes...");

                    for (int i = 0; i <= shortNumberOfProcessesToStart; i++) {
                        ourChildProcesses[i].Kill();
                    }

                    Console.WriteLine("Test complete.");
                }
            }
            catch (Exception ex) {
                Console.WriteLine(ex.Message);
            }
        }
    }
}